/*! Snowflakes | © 2023 Denis Seleznev | MIT License | https://github.com/hcodes/snowflakes/ */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):(t="undefined"!=typeof globalThis?globalThis:t||self).Snowflakes=e()}(this,(function(){"use strict";var t="";function e(e,n){Object.keys(n).forEach((function(i){var o=i;t&&i.search("animation")>-1&&(o=t+i[0].toUpperCase()+i.substr(1)),e.style[o]=n[i]}))}function n(t){e(t,{display:"block"})}function i(t){e(t,{display:"none"})}function o(t){t&&t.parentNode&&t.parentNode.removeChild(t)}function a(t,e){t.classList.add(e)}function s(t,e){t.classList.remove(e)}"undefined"!=typeof window&&(t=Array.prototype.slice.call(window.getComputedStyle(document.documentElement,"")).join(",").search(/,animation/)>-1?"":"webkit");var r="undefined"!=typeof document&&"onanimationend"in document;function h(t,e){return t+Math.floor(Math.random()*(e-t))}function d(t,e,n,i,o){return i+(o-i)*(t-e)/(n-e)}function l(t,e,n){return Math.floor(d(t,0,20,e,n))}var m=function(){function t(t){var e=this;this.size=0,this.sizeInner=0;var n=this.elem=document.createElement("div"),i=this.elemInner=document.createElement("div");this.update(t),a(n,"snowflake"),a(i,"snowflake__inner"),a(n,"snowflake_animation"),r?(a(n,"snowflake_animation-end"),n.onanimationend=function(i){i.target===n&&(e.update(t),e.reflow())}):a(n,"snowflake_animation-infinity"),t.types&&a(i,"snowflake__inner_type_"+h(0,t.types)),t.wind&&a(i,"snowflake__inner_wind"),t.rotation&&a(i,"snowflake__inner_rotation"+(Math.random()>.5?"":"_reverse")),n.appendChild(i)}return t.prototype.update=function(t){if(this.elem&&this.elemInner){var n=t.minSize===t.maxSize;this.sizeInner=n?0:h(0,20),this.size=l(this.sizeInner,t.minSize,t.maxSize);var i=this.getAnimationProps(t),o={animationName:"snowflake_gid_".concat(t.gid,"_y"),animationDelay:i.animationDelay,animationDuration:i.animationDuration,left:99*Math.random()+"%",top:-Math.sqrt(2)*this.size+"px",width:this.size+"px",height:this.size+"px"};n||(o.opacity=String(d(this.size,t.minSize,t.maxSize,t.minOpacity,t.maxOpacity))),e(this.elem,o);var a="snowflake_gid_".concat(t.gid,"_x_").concat(this.sizeInner);e(this.elemInner,{animationName:a,animationDelay:4*Math.random()+"s"})}},t.prototype.reflow=function(){this.elem&&(i(this.elem),this.elem.offsetHeight,n(this.elem))},t.prototype.resize=function(t){var n=this.getAnimationProps(t);this.elem&&e(this.elem,n)},t.prototype.appendTo=function(t){this.elem&&t.appendChild(this.elem)},t.prototype.destroy=function(){this.elem&&(this.elem.onanimationend=null),delete this.elem,delete this.elemInner},t.prototype.getAnimationProps=function(t){var e=t.containerHeight/50/t.speed,n=e/3;return{animationDelay:Math.random()*e+"s",animationDuration:String(d(this.size,t.minSize,t.maxSize,e,n)+"s")}},t}();return function(){function t(e){var n=this;this.destroyed=!1,this.flakes=[],this.isBody=!1,this.handleResize=function(){n.params.autoResize&&n.resize()},this.handleOrientationChange=function(){n.resize()},this.params=this.setParams(e),this.isBody=this.params.container===document.body,t.gid++,this.gid=t.gid,this.container=this.appendContainer(),this.params.stop&&this.stop(),this.appendStyles(),this.appendFlakes(),this.containerSize={width:this.width(),height:this.height()},window.addEventListener("resize",this.handleResize,!1),screen.orientation&&screen.orientation.addEventListener&&screen.orientation.addEventListener("change",this.handleOrientationChange)}return t.prototype.start=function(){s(this.container,"snowflakes_paused")},t.prototype.stop=function(){a(this.container,"snowflakes_paused")},t.prototype.show=function(){s(this.container,"snowflakes_hidden")},t.prototype.hide=function(){a(this.container,"snowflakes_hidden")},t.prototype.resize=function(){var t=this.width(),e=this.height();if(this.containerSize.width!==t||this.containerSize.height!==e){this.containerSize.width=t,this.containerSize.height=e;var o=this.getFlakeParams();i(this.container),this.flakes.forEach((function(t){return t.resize(o)})),this.updateAnimationStyle(),n(this.container)}},t.prototype.destroy=function(){this.destroyed||(this.destroyed=!0,t.instanceCounter&&t.instanceCounter--,this.removeStyles(),o(this.container),this.flakes.forEach((function(t){return t.destroy()})),this.flakes=[],window.removeEventListener("resize",this.handleResize,!1),screen.orientation&&screen.orientation.removeEventListener&&screen.orientation.removeEventListener("change",this.handleOrientationChange,!1))},t.prototype.appendContainer=function(){var t=document.createElement("div");return a(t,"snowflakes"),a(t,"snowflakes_gid_".concat(this.gid)),this.isBody&&a(t,"snowflakes_body"),e(t,{zIndex:String(this.params.zIndex)}),this.params.container.appendChild(t),t},t.prototype.appendStyles=function(){t.instanceCounter||(this.mainStyleNode=this.injectStyle('.snowflake{pointer-events:none;position:absolute;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;will-change:transform}.snowflake_animation{-webkit-animation:snowflake_unknown 10s linear;animation:snowflake_unknown 10s linear}.snowflake_animation-infinity{-webkit-animation-iteration-count:infinite;animation-iteration-count:infinite}.snowflake__inner,.snowflake__inner:before{bottom:0;left:0;position:absolute;right:0;top:0}.snowflake__inner:before{background-size:100% 100%;content:""}.snowflake__inner_wind{-webkit-animation:snowflake_unknown 2s ease-in-out infinite alternate;animation:snowflake_unknown 2s ease-in-out infinite alternate}.snowflake__inner_rotation:before{-webkit-animation:snowflake_rotation 10s linear infinite;animation:snowflake_rotation 10s linear infinite}.snowflake__inner_rotation_reverse:before{-webkit-animation:snowflake_rotation_reverse 10s linear infinite;animation:snowflake_rotation_reverse 10s linear infinite}@-webkit-keyframes snowflake_rotation{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}to{-webkit-transform:rotate(1turn);transform:rotate(1turn)}}@keyframes snowflake_rotation{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}to{-webkit-transform:rotate(1turn);transform:rotate(1turn)}}@-webkit-keyframes snowflake_rotation_reverse{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}to{-webkit-transform:rotate(-1turn);transform:rotate(-1turn)}}@keyframes snowflake_rotation_reverse{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}to{-webkit-transform:rotate(-1turn);transform:rotate(-1turn)}}.snowflakes{pointer-events:none}.snowflakes_paused .snowflake,.snowflakes_paused .snowflake__inner,.snowflakes_paused .snowflake__inner:before{-webkit-animation-play-state:paused;animation-play-state:paused}.snowflakes_hidden{visibility:hidden}.snowflakes_body{height:1px;left:0;position:fixed;top:0;width:100%}')),t.instanceCounter++,this.imagesStyleNode=this.injectStyle("".replace(/:color:/g,encodeURIComponent(this.params.color))),this.animationStyleNode=this.injectStyle(this.getAnimationStyle())},t.prototype.injectStyle=function(t,e){return function(t,e){return e||(e=document.createElement("style"),document.body.appendChild(e)),e.textContent=t,e}(t.replace(/_gid_value/g,"_gid_".concat(this.gid)),e)},t.prototype.getFlakeParams=function(){var t=this.height(),e=this.params;return{containerHeight:t,gid:this.gid,count:e.count,speed:e.speed,rotation:e.rotation,minOpacity:e.minOpacity,maxOpacity:e.maxOpacity,minSize:e.minSize,maxSize:e.maxSize,types:e.types,wind:e.wind}},t.prototype.appendFlakes=function(){var t=this,e=this.getFlakeParams();this.flakes=[];for(var n=0;n<this.params.count;n++)this.flakes.push(new m(e));this.flakes.sort((function(t,e){return t.size-e.size})).forEach((function(e){e.appendTo(t.container)}))},t.prototype.setParams=function(t){var e=t||{},n={},i={color:"#5ECDEF",container:document.body,count:50,speed:1,stop:!1,rotation:!0,minOpacity:.6,maxOpacity:1,minSize:10,maxSize:25,types:6,width:void 0,height:void 0,wind:!0,zIndex:9999,autoResize:!0};return Object.keys(i).forEach((function(t){n[t]=void 0===e[t]?i[t]:e[t]})),n},t.prototype.getAnimationStyle=function(){for(var t=this.height()+this.params.maxSize*Math.sqrt(2)+"px",e=this.gid,n="@-webkit-keyframes snowflake_gid_".concat(e,"_y{from{-webkit-transform:translateY(").concat("0px",")}to{-webkit-transform:translateY(").concat(t,");}}\n@keyframes snowflake_gid_").concat(e,"_y{from{transform:translateY(").concat("0px",")}to{transform:translateY(").concat(t,")}}"),i=0;i<=20;i++){var o=l(i,this.params.minSize,this.params.maxSize)+"px";n+="@-webkit-keyframes snowflake_gid_".concat(e,"_x_").concat(i,"{from{-webkit-transform:translateX(0px)}to{-webkit-transform:translateX(").concat(o,");}}\n@keyframes snowflake_gid_").concat(e,"_x_").concat(i,"{from{transform:translateX(0px)}to{transform:translateX(").concat(o,")}}")}return n},t.prototype.updateAnimationStyle=function(){this.injectStyle(this.getAnimationStyle(),this.animationStyleNode)},t.prototype.removeStyles=function(){t.instanceCounter||(o(this.mainStyleNode),delete this.mainStyleNode),o(this.imagesStyleNode),delete this.imagesStyleNode,o(this.animationStyleNode),delete this.animationStyleNode},t.prototype.width=function(){return this.params.width||(this.isBody?(e=document.body,n=document.documentElement,window.innerWidth?t=window.innerWidth:n&&n.clientWidth?t=n.clientWidth:e&&(t=e.clientWidth),t||0):this.params.container.offsetWidth);var t,e,n},t.prototype.height=function(){return this.params.height||(this.isBody?(e=document.body,n=document.documentElement,window.innerHeight?t=window.innerHeight:n&&n.clientHeight?t=n.clientHeight:e&&(t=e.clientHeight),t||0):this.params.container.offsetHeight+this.params.maxSize);var t,e,n},t.instanceCounter=0,t.gid=0,t}()}));